.model small
.stack
.data
        prompt        db "Iveskite 4-zenkli HEX skaiciu (pvz. 89AB)", 0ah, 0dh, "> $"
        errormsg      db "File read/write error.", 0ah, 0dh, "$"
        newline       db 0ah, 0dh, 0ah, 0dh, "$"
        outputbuf     db 16 dup(0), "$"
        strbuf        db 5
                      db 0
                      db 5 dup(0)
        handle        dw 0000h
        helpnote      db "Pagalba:", 0ah, 0dh, 0ah, 0dh, "Programos pradzioje reikia "
                      db "ivesti keturzenkli sesioliktaini skaiciu. Parametru ivesti nereikia.", 0ah, 0dh, 0ah, 0dh
                      db "pvz.: 89AB", 0ah, 0dh, 0ah, 0dh
                      db "Programa isves dvejetaini sito skaicio varianta.$"

.code
        mov ax, @data
        mov ds, ax
        
        mov ch, 0
        mov cl, [es:0080h]
        cmp cx, 0
        je .cont
        mov	bx, 0081h
.srch:  cmp [es:bx], '?/'
        je .help
        inc bx
        loop .srch

.help:  mov dx, offset helpnote
        call print
        jmp exit
        
.cont:  mov dx, offset prompt
        call print
        
        mov dx, offset strbuf
        call input
        
; ----- INPUT -----
        
        mov si, offset strbuf+2
        mov byte ptr [si+4], 0
        
; +--------------------------------------------------------+
; |          Transforming ASCII stuff to a number          |
; +--------------------------------------------------------+

        mov si, offset strbuf+2
        dec si
.loop:  inc si
        mov al, [si]

        or al, al
        jz .done
        
        ; --------
        cmp al, 30h            ; if not <30h and not >39h
        jb .loop
        cmp al, 39h
        jg .test
        ; ---------
        sub al, 30h            ; shifting ASCII range to make them numbers [00-09]
        mov byte ptr [si], al
        jmp .loop
        
.test:  cmp al, 41h            ; if not <41h and not >46h
        jb .loop
        cmp al, 46h
        jg .test2
        sub al, 37h            ; shifting ASCII range to make them numbers [0A-0F]
        mov byte ptr [si], al
        jmp .loop
        
.test2: cmp al, 61h            ; if not <41h and not >46h
        jb .loop
        cmp al, 66h
        jg .test2
        sub al, 57h            ; shifting ASCII range to make them numbers [0A-0F]
        mov byte ptr [si], al
        jmp .loop
        
; +--------------------------------------------------------+
; |   Transforming string of numbers to a single number    |
; +--------------------------------------------------------+
    
.done:  mov si, offset strbuf+2
        xor ax, ax
        xor cx, cx

        mov cl, [si]            ; first byte
        xor ch, ch
        and cl, 00001111b       ; negate any tail, to make it 4 bit.
        add ax, cx
        shl ax, 4
        
        mov cl, [si+1]          ; next byte
        xor ch, ch
        and cl, 00001111b       ; negate any tail, to make it 4 bit.
        add ax, cx
        shl ax, 4
        
        mov cl, [si+2]          ; yet another byte
        xor ch, ch
        and cl, 00001111b       ; negate any tail, to make it 4 bit.
        add ax, cx
        shl ax, 4
        
        mov cl, [si+3]          ; final byte
        xor ch, ch
        and cl, 00001111b       ; negate any tail, to make it 4 bit.
        add ax, cx
        
; +--------------------------------------------------------+
; | Transforming AX to a binary string (using 30h and 31h) |
; +--------------------------------------------------------+
        
        mov dx, ax
        mov cx, 16
        mov si, offset outputbuf+14
.loop2: and al, 1
        add al, 30h
        mov byte [si], al
        dec si
        shr dx, 1
        mov ax, dx
        loop .loop2

; ----- OUTPUT -----
        mov dx, offset newline
        call print
        
        mov dx, offset outputbuf
        call print
         
exit:   mov ah, 4ch
        mov al, 00h
        int 21h
        
error:  mov dx, offset errormsg
        call print
        jmp exit
        
; --------------------------------------------------------    
; ----- PROCEDURES -----

input proc
        mov ah, 0ah
        int 21h
        ret
input endp

print proc
        mov ah, 09h
        int 21h
        ret
print endp

end
